<!DOCTYPE html>
<html lang="en">
  <head>
    <title>task520postlist</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  </head>
  <body onload="onPageLoading()">
    <div class="container">
      <div class="row">
        <div class="jumbotron bg-light col-sm-6 mx-auto">
          <h3 class="text-center text-info">
           DETAIL COMMENT
          </h3>
          <div class="row form-group">
            <label class="col-sm-2 col-form-label">ID</label>
            <div class="col-sm-10">
              <input
                type="text"
                class="form-control"
                id="inp-id"
                placeholder="..."
              />
            </div>
          </div>
          <div class="row form-group">
            <label class="col-sm-2 col-form-label">Post ID</label>
            <div class="col-sm-10">
              <input
                type="text"
                class="form-control"
                id="inp-post-id"
                placeholder="..."
              />
            </div>
          </div>
          <div class="row form-group">
            <label class="col-sm-2 col-form-label">Email</label>
            <div class="col-sm-10">
              <input
                type="email"
                class="form-control"
                id="inp-email"
                placeholder="..."
              />
            </div>
          </div>
          <div class="row form-group">
            <label class="col-sm-2 col-form-label">Name</label>
            <div class="col-sm-10">
              <input
                type="text"
                class="form-control"
                id="inp-name"
                placeholder="..."
              />
            </div>
          </div>
          <div class="row form-group">
            <label class="col-sm-2 col-form-label">Body</label>
            <div class="col-sm-10">
              <textarea
                type="text"
                rows="4"
                class="form-control"
                id="inp-body"
                placeholder="..."
              ></textarea>
            </div>
          </div>
          <div class="row form-group">
            <button class="btn btn-info" id="btn-come-back">
              Back to home page
            </button>
          </div>
        </div>
      </div>
    </div>
    <script>
      "use strict";
      /*** REGION 1 - Global variables - Vùng khai báo hằng số, tham số TOÀN CỤC */
      var gBASE_URL = "https://jsonplaceholder.typicode.com";
      var gInputId = $("#inp-id");
      var gInputPostId = $("#inp-post-id");
      var gInputEmail = $("#inp-email");
      var gInputName = $("#inp-name");
      var gInputBody = $("#inp-body");
      var gPortId = "";
      var gCmtIDObj = { commentId: 0 };

      /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
      $(document).ready(function () {
        onPageLoading();
        //khai báo button click come back to page
        $("#btn-come-back").on("click", onBtnBack);
      });

      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      //load dữ liệu đổ vào form
      function onPageLoading() {
        "use strict";

        //read data from list post
        readDataPostIdObject(gCmtIDObj);
        var vIsCheck = validateForm(gCmtIDObj);
        if (vIsCheck) {
          callSeverByGetAjax(gCmtIDObj);
        }
      }

      function onBtnBack() {
        "use strict";
        const vFORM_TO_OPEN = "task520postlist.html"; //đây là form sẽ mở
        var vUrlPage = vFORM_TO_OPEN + "?" + "port_id=" + gPortId;
        window.location.href = vUrlPage;
      }

      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      //get ajax
      function callSeverByGetAjax(paramCmtIDObj) {
        const vAPI_URL = gBASE_URL + "/comments/" + paramCmtIDObj.commentId;
        $.ajax({
          url: vAPI_URL,
          type: "GET",
          dataType: "json",
          success: function (responseObject) {
            console.log(JSON.stringify(responseObject));
            loadDataToForm(responseObject);
          },
          error: function (ajaxContext) {
            //alert(ajaxContext.responseText);
            alert(
              "Bạn điền ID!!!"
            );
            window.location.href = "task520postlist.html";
          },
        });
      }
      function readDataPostIdObject(paramCmtIDObject) {
        var vUrlString = window.location.href;
        var vURL = new URL(vUrlString);
        var vCmtID = vURL.searchParams.get("id");
        paramCmtIDObject.commentId = vCmtID;
      }
      function validateForm(paramCmtIDObject) {
        if (paramCmtIDObject.commentId === "") {
          alert("Vui lòng nhập!");
          return false;
        }
        if (isNaN(paramCmtIDObject.commentId)) {
          alert("Vui lòng nhập số nguyên!");
          return false;
        }
        return true;
      }

      //load dữ liệu đến form
      function loadDataToForm(paramObj) {
        gInputId.val(paramObj.id);
        gInputPostId.val(paramObj.postId);
        gInputEmail.val(paramObj.email);
        gInputName.val(paramObj.name);
        gInputBody.val(paramObj.body);
      }
    </script>
  </body>
</html>

